• leetcode 694. Number of Distinct Islands


    Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are surrounded by water.

    Count the number of distinct islands. An island is considered to be the same as another if and only if one island can be translated (and not rotated or reflected) to equal the other.

    Example 1:
    11000
    11000
    00011
    00011
    Given the above grid map, return 1.
    Example 2:
    11011
    10000
    00001
    11011
    Given the above grid map, return 3.
    
    Notice that:
    11
    1
    and
     1
    11
    are considered different island shapes, because we do not consider reflection / rotation.
    

    题目大意,求不同小岛的数量
    矩阵中每个点都可以表示成 i*col + j的形式,比如第一个样例的两个岛可以写成(0,1,5,6)(13,14,18,19) 那么如何判断这两个岛是否相等呢
    把这两个数组平移到0行y列就可以了。(注意y是小岛最小的左边界)。 就是减去每个数组x的最小值和y的最小值。 那么(0,1,5,6)和(13,14,18,19)-13就相等了,所以他们是一个形状的岛

    class Solution {
    public:
        int dir[4][2] = {1,0,0,1,0,-1,-1,0};
        int n, m, ans, cntx, cnty;
        map<pair<int,int>, int>mp;
        vector<int> v;
        vector<set<int> > w;
        void dfs(int x, int y, vector<vector<int>>& grid) {
            mp[{x, y}] = 1;
            v.push_back(x * m + y);
            cntx = min(cntx, x);
            cnty = min(cnty, y);
            for (int i = 0; i < 4; ++i) {
                int nx = x + dir[i][0];
                int ny = y + dir[i][1];
                if (nx < n && ny < m && nx >=0 && ny >= 0 && !mp[{nx,ny}] && (grid[nx][ny] == 1)) {
                    dfs(nx, ny, grid);
                }
            }
        }
        int numDistinctIslands(vector<vector<int>>& grid) {
            n = grid.size();
            if (n == 0) return 0;
            m = grid[0].size();
            mp.clear();
            ans = 0;
            
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (mp[{i,j}] == 0 && grid[i][j] == 1) {
                        cntx = cnty = 100000000;
                        v.clear();
                        dfs(i, j, grid);
                        cout << "cnt " << cntx <<" " << cnty << endl;
                        set<int>se;
                        for(auto xp : v) {
                            se.insert(xp-cntx*m-cnty);
                        }
                        w.push_back(se);
                    }
                }
            }
            if (w.size()) ans = 1;
            else return 0;
            sort(w.begin(), w.end());
            for (int i = 1; i < w.size(); ++i) {
                if (w[i] != w[i-1]) ans++;
            }
            return ans;
        }
    };
    /*
    011
    111
    000
    111
    110
    */
    /*
    1 4 5 2 3 
    9 12 13 10 11 
    */
    
  • 相关阅读:
    深入理解JavaScript中的this关键字
    使用yii的layout,加入<?php echo $content; ?>这句话时,它会自动在子页面上面添加一个div包裹
    使用 BEGINCONTENT() 和 ENDCONTENT() 设定 YII 的 LAYOUTS
    孙悟空的师傅是谁
    PHP MemCached高级缓存配置图文教程
    C++中的基类与派生类
    矩阵快速幂
    华为上机测试题
    2016网易研发题目
    冒泡排序
  • 原文地址:https://www.cnblogs.com/pk28/p/7636872.html
Copyright © 2020-2023  润新知